pr def GenRegM2
    args Snr model Yvar Xvars IFbs
	
forvalues s = 1(1)`Snr' { 
display("`s'")
quietly { // To obtain random simulations of the standard-deviation of the wage use:  g simu_SD = sqrt( (VAR_ln_wage/(Nemp-1))*rchi2(1) )
use "$path_g\\${data_save}_dtbc3.dta", clear   //local s = ceil(1000*runiform())   
BS_Var_Pinc_UnR_DPIR `s' 
`IFbs'
`model' `Yvar' `Xvars', vce(robust) iterate(30)
matrix define Beta = e(b)
matrix define VarM = e(V)
local kmax0=colsof(Beta)
g Beta=.
g SEbeta=.
forv coef_nr=1/`kmax0' {
local coefv = Beta[1,`coef_nr']   //local name_varx = word("`vars`eqn_nr''", `coef_nr')  replace `name_var' = `name_var'+`name_varx'*`coefv'
replace Beta=`coefv' if _n==`coef_nr'
local coefv = sqrt( VarM[`coef_nr',`coef_nr'] )
replace SEbeta=`coefv' if _n==`coef_nr'
}
matrix drop Beta VarM
keep Beta SEbeta
keep if Beta<.
g CoefN=_n
g bs_rep = `s' 
if `s'>1 {
joinby bs_rep CoefN using "$path_g\\BSprob0_`Yvar'.dta", unmatched(both) update
drop _merge
}
save "$path_g\\BSprob0_`Yvar'.dta", replace
}  
} 

end
