pr def SEmean_ene
    args var_list
quietly {
use "$path2\ene_temp_${data_save_emp}.dta", clear
sum duration_unem if duration_unem>=1
local min_c=r(min)
local max_c=r(max)
keep if cse>0 & cse<5 // Consider only labor force workers
drop if unemployed==.
drop if labor_force_p==0

sum employed unemployed unemployed2 layoffs layoffs3 duration_unem duration_un_mean S_* f_*  // labor_force_p pr_layoffs3 pr_layoffs4
g Nemp=1 if unemployed<.	
collapse (sum) Nemp (semean) employed unemployed unemployed2 layoffs layoffs3 duration_unem duration_un_mean, by (year quarter `var_list')   //[fw=factor_esi]
foreach x of local var_list {  
drop if `x'==.  // Drop values with missing cross-terms
}
foreach x of varlist employed unemployed unemployed2 layoffs layoffs3 duration_unem duration_un_mean {  
rename `x' SE_`x'
}
rename Nemp Nemp_ENE
sort year `var_list'
compress
}
end
