quietly { //quietly noisily
local year=2019
forv qr=3/4 {
display "`year'Q`qr'"	
adapt_ene `year' `qr'   // 0 - Adapting several years of the ESI to be equivalente
adapt_ene2 `year' `qr'
if `year'>2019  | `qr'>=4 {
joinby id_identificacion id_persona ano_encuesta mes_encuesta using "$path2\eneCS_all.dta", unmatched(both) update
tab _merge
drop _merge
}
save "$path2\eneCS_all.dta", replace
}
local year=2020
forv qr=1/4 {
display "`year'Q`qr'"	
adapt_ene `year' `qr'   // 0 - Adapting several years of the ESI to be equivalente
adapt_ene2 `year' `qr'
if `year'>2019  | `qr'>=4 {
joinby id_identificacion id_persona ano_encuesta mes_encuesta using "$path2\eneCS_all.dta", unmatched(both) update
tab _merge
drop _merge
}
save "$path2\eneCS_all.dta", replace
}
order id* an* mes* year quarter, first
capture drop id_upm idrph_preliminar id_directorio id_hogar

recode hor_hab 140/.=.
recode hor_efe 140/.=.
replace hor_hab=hor_efe if hor_hab==.
replace hor_efe=hor_hab if hor_efe==.
sum employed hor_* if employed==1
label define sexoE 1 "Men" 2 "Women"
label values sexo sexoE
label define educE 1 "Secondary or less" 2 "Technical educ." 3 "College or more"
label values educ educE
label define actE 1 "Agriculture" 2 "Mining" 3 "Manufacturing" 4 "Energy" 5 "Construction" 6 "Retail" 7 "Transports, Lodging, ICT" 8 "Banks and finance" 9 "Public administration, Education, Services"
label values actividad actE
label define sectE 1 "Primary" 2 "Secondary" 3 "Tertiary"
label values sector_ind sectE

egen IDworker=group(id*)
g date = yq(year,quarter)   // egen date=group(year quarter)
xtset IDworker date
g lag_unemployed = L.unemployed
g jobfind = 0 if lag_unemployed==1 & unemployed<.
replace jobfind = 1 if unemployed==0 & lag_unemployed==1
tab actividad
g lag_educ= L.educ
replace educ=lag_educ if educ==.
replace educ=1 if educ==.
foreach varf of varlist actividad {  // sector_ind
g lag_`varf'= L.`varf'
replace `varf'=lag_`varf' if `varf'==. & unemployed<.
bysort zona2 educ tr_edad: egen `varf'_mode = mode(`varf')  
tab `varf'_mode
replace `varf'=`varf'_mode if `varf'==. & unemployed<.
drop lag_`varf' `varf'_mode
}
replace sector_ind=1 if actividad>=1 & actividad<=2 & sector_ind==.
replace sector_ind=2 if actividad>=3 & actividad<=5 & sector_ind==.
replace sector_ind=3 if actividad>=6 & actividad<=9 & sector_ind==.
g Labor_Force = 1 if cae_general>=1 & cae_general<=5
replace Labor_Force = 0 if Labor_Force==.
save "$path2\eneCS_all.dta", replace
}
//
