local Ri = 0.15
g C0 = `Ri'/( 1-(1+`Ri')^(-max(6,min(48,p_cons))) )
local Ri = 0.20 // 5% increase in interest rates for consumer debt
g C1 = `Ri'/( 1-(1+`Ri')^(-max(6,min(48,p_cons))) )
local Ri = 0.25 // 10% increase in interest rates for consumer debt
g C2 = `Ri'/( 1-(1+`Ri')^(-max(6,min(48,p_cons))) )
g adj1 = min(1.5, max(1,C1/C0)) if a1==1
g adj2 = min(1.5, max(1,C2/C0)) if a1==1
g ing2 = (exp(ing)+exp(ytoth_pi)+exp(ing_original))/3 if a1==1
replace ing2 = max(exp(ing),ing2,(exp(ing)+exp(ing_original))/2,(exp(ing)+exp(ytoth_pi))/2) if a1==1

g expenses3_2 = expenses3 if a1==1
replace expenses3_2 = expenses3_2-0.50*exp_red if a1==1 & ing<ing_p50 & ing_p50<.
replace expenses3_2 = expenses3_2-0.50*exp_red if a1==1 & ing<ing_p25 & ing_p25<.

g adj3 = max(0, 2*(expenses3_2-ing2-am_dna)/max(exp(ing_ori),ing2,d_dna) )  if a1==1  //1.5 2 3  //am_dna
replace adj3 = min(3, adj3, min(0.50*dc_p90,d_dna)/max(exp(ing_ori),ing2,d_dna) )  if a1==1
replace adj3 = min(adj3,1.5) if a1==1 & dr2==0

local drI = "dr3 dr3_cc2" // dr3I2 //local drI = "dr1 dr2 dr3 dr1_cc2 dr2_cc2 dr3_cc2 dr3I1 dr3I2"
local drI2 = "dr3I1"
local dfL = "${dfL}"
local k=1
replace rci_pend_75 = min( 1.5, rci_pend_75+max(0,adj1*max(0,cf_dna)*adj3/exp(ing))) if rci_pend_75<. & a1==1
replace debt_pi_ratio = min(2, debt_pi_ratio+max(0,adj1*max(0,d_dna)*adj3/max(ing2,exp(ytoth_pi)))) if debt_pi_ratio<. & a1==1 //min(1,debt_pi_ratio*adj)
foreach var1 of local dfL {
local dfM1=word("${dfM}",`k') // global dfM="df_TB df_TCC df_Vall df3_dna df_dna_k3" //"bc1_TB bc1_TCC bc_V3 bc3_X0 bc4_X0"
predict_pr_dfBS `var1'_u${Ii}_vs2 `dfM1' "${dfV`k'}" "if a1==1 ${cond`k'}"   //predict_pr_df `var1'_u${Ii}_vs2 `dfM1' "${dfV`k'}" "if a1==1" 
local k=1+`k'
}
g expenses3_new1 = expenses3_2 + max(0,adj1*max(0,cf_dna)*adj3) if a1==1 // Interest rate shock 1
g expenses3_new2 = expenses3_2 + max(0,adj2*max(0,cf_dna)*adj3) if a1==1 // Interest rate shock 2

g dr3_${Ii} = (expenses3_2>ing2 & d_dna>dc_p90) if a1==1 & d_dna<.  //& df_dna<.
g dr3_cc2_${Ii} = (expenses3_2>ing2 & d_dna>${PcdebtCS}*dc_p90) if a1==1 & d_dna<.  //& df_dna<.
g dr3I1_${Ii} = (expenses3_new1>ing2 & d_dna>dc_p90) if a1==1 & d_dna<.  //& df_dna<.
foreach var1 of local dfL {
foreach var2 of local drI {
g `var1'_`var2'_u${Ii} = `var1'_u${Ii} if a1==1 & `var1'_u${Ii}<.  //max(`var1'_u${Ii},`var2'_${Ii})
replace `var1'_`var2'_u${Ii} = max(`var1'_u${Ii},min(${DfCS},${DfCS2})) if a1==1 & `var1'_u${Ii}<. & dr2==1 & `var2'_${Ii}==0 
replace `var1'_`var2'_u${Ii} = max(`var1'_u${Ii},${DfCS}) if a1==1 & `var1'_u${Ii}<. & dr2==0 & `var2'_${Ii}==1 
replace `var1'_`var2'_u${Ii} = max(`var1'_u${Ii},max(${DfCS},${DfCS3})) if a1==1 & `var1'_u${Ii}<. & dr2==1 & `var2'_${Ii}==1 
} 
foreach var2 of local drI2 {
g `var1'_`var2'_u${Ii} = max(`var1'_u${Ii},`var1'_u${Ii}_vs2) if a1==1 & `var1'_u${Ii}<.  //max(`var1'_u${Ii},`var2'_${Ii})
replace `var1'_`var2'_u${Ii} = max(`var1'_u${Ii},${DfCS2}) if a1==1 & `var1'_u${Ii}<. & dr2==1 & `var2'_${Ii}==0 
replace `var1'_`var2'_u${Ii} = max(`var1'_u${Ii},${DfCS}) if a1==1 & `var1'_u${Ii}<. & dr2==0 & `var2'_${Ii}==1 
replace `var1'_`var2'_u${Ii} = max(`var1'_u${Ii},max(${DfCS},${DfCS3})) if a1==1 & `var1'_u${Ii}<. & dr2==1 & `var2'_${Ii}==1 
} 
} 
drop expenses3_new1 expenses3_new2 adj1 adj2 adj3 C2 C1 C0 ing2 expenses3_2 *_u${Ii}_vs2
