local yr=17  // 11 14 17 // min_dvp min_dTBTCC min_dna  // local vlV2 = "ing rci_pend_75 numh edad d_z2" //rda 
local vlX0 = "unemp_sect ing debt_pi_ratio rci_pend_75 us_rci_75 numh edad hombre_casado instituto universidad d_z2" // genero d_cc2 
local vlV = "ing rda debt_pi_ratio rci_pend_75 numh edad hombre_casado genero instituto universidad unemp_sect d_z2" //rda  d_cc2
global BSrefs_op "\\StandardRegs\ENE Bootstrap only\\"   // "\\\RobChecks\\ENE Bootstrap only\\"
local RopN = ""  //local Rop=1   // 0  Standard Regs, 1 RobChecks
if ${Rop}==1 | ${Rop}==3 { //if `Rop'==1 {    
local vlX0 = "noLiqAdummy rLiqFAssetsDebt unemp_sect ing debt_pi_ratio rci_pend_75 us_rci_75 numh edad hombre_casado instituto universidad d_z2" // genero d_cc2 
local vlV = "noLiqAdummy rLiqFAssetsDebt ing rda debt_pi_ratio rci_pend_75 numh edad hombre_casado genero instituto universidad unemp_sect d_z2" //rda  d_cc2
global BSrefs_op "\\\RobChecks\\ENE Bootstrap only\\"
local RopN = "Rob"
}
if ${Rop}>=2 { 
local RopN = "`RopN'MeanBeta"  
}
//

use "$path_g\\EFH_BS${BS_nr}.dta", clear //  Apply labor market stress test   // 
capture g OR_rLiqFAssetsDebt = rLiqFAssetsDebt
capture g OR_noLiqAdummy = noLiqAdummy
foreach i of numlist $STs { // forvalues i = 60(5)100 {  //  Tarjetas: unemployment shocks
capture drop simul_unemp ytot_ind_loss ytoth_loss dur_unem ytot_ind_loss_dur ytot_ind_loss_yr ytoth_loss_yr
global Ii=`i' //${Ii}
if ${Ii}==80 {    // Add October shock
rename folio_efh folio_efh0
rename original_folio_efh folio_efh
drop *orig*     // here merge saves 32 seconds relative to joinby
merge m:1 folio_efh ord year_efh using "$path_g\\EFH_Oct2019.dta", update  //joinby folio_efh ord year_efh using  "$path_g\\EFH_Oct2019.dta", unmatched(master) update
capture tab _merge  //replace unemp_sect_origi = max(layoffs_S, unemp_sect_origi)  drop layoffs_S
keep if _merge==3
sum *orig*
foreach var of varlist unemp_sect rci_pend_75 us_rci_75 debt_pi_ratio rda {   
replace `var' = max(`var' , `var'_original) if `var'_original<. 
replace `var'_original = max(`var', `var'_original) if `var'_original<. 
}
foreach var of varlist ytot_ind ing {  
replace `var' = min(`var' , `var'_original) if `var'_original<. 
replace `var'_original = min(`var', `var'_original) if `var'_original<. 
}
rename folio_efh original_folio_efh 
rename folio_efh0 folio_efh
capture drop _merge
}  // run "$path_bs_do\SUF_IFE_vs2.do" 
run "$path_bs_do\Unemp_Dur_Shock.do"  // Simulate Unemployment, then Duration, then get default probability (1 month, All and Bank)  
predict_pr_dfBS dfTB_u`i' df_TB "`vlX0'" "if a1==1 & df_TB<."
predict_pr_dfBS dfTCC_u`i' df_TCC "`vlX0'" "if a1==1 & df_TCC<."
predict_pr_dfBS df3V_u`i' df_Vall "`vlV'" "if a1==1 & d_vp>0 & d_vp<. & df3V<."
predict_pr_dfBS df3_u`i' df3_dna "`vlX0'" "if a1==1 & cf_dt>0 & cf_dt!=. & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<. & df3_dna<."
predict_pr_dfBS dfK3_u`i' df_dna_k3 "`vlX0'" "if a1==1 & cf_dt>0 & cf_dt!=. & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<. & df_dna_k3<."
run "$path_bs_do\YVol_LaborQ_shocks.do"  // Simulate Other Employment shocks then get default probability 
predict_pr_dfBS dfQTB_u`i' df_TB "`vlX0'" "if a1==1 & df_TB<."
predict_pr_dfBS dfQTCC_u`i' df_TCC "`vlX0'" "if a1==1 & df_TCC<."
predict_pr_dfBS dfQ3V_u`i' df_Vall "`vlV'" "if a1==1 & d_vp>0 & d_vp<. & df3V<."
predict_pr_dfBS dfQ3_u`i' df3_dna "`vlX0'" "if a1==1 & cf_dt>0 & cf_dt!=. & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<. & df3_dna<."
predict_pr_dfBS dfQK3_u`i' df_dna_k3 "`vlX0'" "if a1==1 & cf_dt>0 & cf_dt!=. & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<. & df_dna_k3<."
global dfL = "dfQTB dfQTCC dfQ3V dfQ3 dfQK3"
global dfM = "df_TB df_TCC df_Vall df3_dna df_dna_k3" //"bc1_TB bc1_TCC bc_V3 bc3_X0 bc4_X0"
global cond1 " & df_TB<."
global cond2 " & df_TCC<."
global cond3 " & d_vp>0 & d_vp<. & df3V<."
global cond4 " & cf_dt>0 & cf_dt!=. & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<. & df3_dna<."
global cond5 " & cf_dt>0 & cf_dt!=. & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<. & df_dna_k3<."
global dfV1="`vlX0'"
global dfV2="`vlX0'"
global dfV3="`vlV'"
global dfV4="`vlX0'"
global dfV5="`vlX0'"
run "$path_bs_do\Credit_shocks.do"  // Add Credit shocks then get default probability 
foreach var of varlist unemp_sect ytot_ind ing rci_pend_75 us_rci_75 debt_pi_ratio rda {
replace `var' = `var'_original
}
} 
capture drop dr3* // End of Tarjetas
foreach i of numlist $STs { // forvalues i = 60(5)100 {  //  Total: unemployment shocks
g dfTall_u`i' = w_dTBTCC*max(0, dfTB_u`i',dfTCC_u`i') + w_dna*max(0,df3_u`i') + w_dvp*max(0,df3V_u`i') if a1==1 & min_Dall>0 & min_Dall<. 
g dfQTall_u`i' = w_dTBTCC*max(0, dfQTB_u`i',dfQTCC_u`i') + w_dna*max(0,dfQ3_u`i') + w_dvp*max(0,dfQ3V_u`i') if a1==1 & min_Dall>0 & min_Dall<. 
g dfQTall_dr3_u`i' = w_dTBTCC*max(0, dfQTB_dr3_u`i',dfQTCC_dr3_u`i') + w_dna*max(0,dfQ3_dr3_u`i') + w_dvp*max(0,dfQ3V_dr3_u`i') if a1==1 & min_Dall>0 & min_Dall<. 
g dfQTall_dr3I1_u`i' = w_dTBTCC*max(0, dfQTB_dr3I1_u`i',dfQTCC_dr3I1_u`i') + w_dna*max(0,dfQ3_dr3I1_u`i') + w_dvp*max(0,dfQ3V_dr3I1_u`i') if a1==1 & min_Dall>0 & min_Dall<. 

g dfKTall_u`i' = wK_dTBTCC*max(0, dfTB_u`i') + wK_dna*max(0,dfK3_u`i') + wK_dvp*max(0,df3V_u`i') if a1==1 & min_Dall>0 & min_Dall<. & dKT==1 // Does it work well? (weights)
g dfQKTall_u`i' = wK_dTBTCC*max(0, dfQTB_u`i') + wK_dna*max(0,dfQK3_u`i') + wK_dvp*max(0,dfQ3V_u`i') if a1==1 & min_Dall>0 & min_Dall<. & dKT==1
g dfQKTall_dr3_u`i' = wK_dTBTCC*max(0, dfQTB_dr3_u`i') + wK_dna*max(0,dfQK3_dr3_u`i') + wK_dvp*max(0,dfQ3V_dr3_u`i') if a1==1 & min_Dall>0 & min_Dall<. & dKT==1 
g dfQKTall_dr3I1_u`i' = wK_dTBTCC*max(0, dfQTB_dr3I1_u`i') + wK_dna*max(0,dfQK3_dr3I1_u`i') + wK_dvp*max(0,dfQ3V_dr3I1_u`i') if a1==1 & min_Dall>0 & min_Dall<. & dKT==1 
}  // End of Total   //  // min_dvp min_dTBTCC min_dna
foreach i of numlist $STs { // forvalues i = 60(5)100 {  //  Total: unemployment shocks
g dfCall_u`i' = wC_dTBTCC*max(0, dfTB_u`i',dfTCC_u`i') + wC_dna*max(0,df3_u`i') if a1==1 & min_DC>0 & min_DC<. 
g dfQCall_u`i' = wC_dTBTCC*max(0, dfQTB_u`i',dfQTCC_u`i') + wC_dna*max(0,dfQ3_u`i') if a1==1 & min_DC>0 & min_DC<. 
g dfQCall_dr3_u`i' = wC_dTBTCC*max(0, dfQTB_dr3_u`i',dfQTCC_dr3_u`i') + wC_dna*max(0,dfQ3_dr3_u`i') if a1==1 & min_DC>0 & min_DC<. 
g dfQCall_dr3I1_u`i' = wC_dTBTCC*max(0, dfQTB_dr3I1_u`i',dfQTCC_dr3I1_u`i') + wC_dna*max(0,dfQ3_dr3I1_u`i') if a1==1 & min_DC>0 & min_DC<. 

g dfKCall_u`i' = wKC_dTBTCC*max(0, dfTB_u`i') + wKC_dna*max(0,dfK3_u`i') if a1==1 & min_DC>0 & min_DC<. & dKC==1 // Does not work so well (weights??)
g dfQKCall_u`i' = wKC_dTBTCC*max(0, dfQTB_u`i') + wKC_dna*max(0,dfQK3_u`i') if a1==1 & min_DC>0 & min_DC<. & dKC==1
g dfQKCall_dr3_u`i' = wKC_dTBTCC*max(0, dfQTB_dr3_u`i') + wKC_dna*max(0,dfQK3_dr3_u`i') if a1==1 & min_DC>0 & min_DC<. & dKC==1 
g dfQKCall_dr3I1_u`i' = wKC_dTBTCC*max(0, dfQTB_dr3I1_u`i') + wKC_dna*max(0,dfQK3_dr3I1_u`i') if a1==1 & min_DC>0 & min_DC<. & dKC==1
}  // End of Total Consumer Debt
keep if a1==1
rename folio_efh folio_efh0
rename original_folio_efh folio_efh
joinby folio_efh year_efh using "$path_g\\EFH_debtFacs.dta", unmatched(master) update
tab _merge
order foli* *efh ord a1 bs_rep fact* estr* quin* sect* constant noLiqAdummy *edad* educ* numh* ytot_p_h ytoth*, first
order df*, last
drop _merge d_unemployed_* pr_jobfind_* *_original OR_*  w* `vlX0' `vlV' ytoth_pi-dc_p90 Hretiro10P-ytot_ind_loss_yr
rename folio_efh original_folio_efh 
rename folio_efh0 folio_efh   //capture g constant=1
char _dta[_mi_update]         
char _dta[_mi_N]              
char _dta[_mi_style]            
char _dta[_mi_marker]          
char _dta[_mi_M]
compress
save "$path_g\\\BS_risk\Mit${Mit}\\EFH_BS${BS_nr}_2`RopN'.dta", replace
