local var_list_pr0 = "ing debt_pi_ratio rci_pend_75 us_rci_75 numh edad hombre_casado genero instituto universidad unemp_sect d_z2 d_cc2"
local var_list_pr0_vp = "ing debt_dt_pi_ratio rci_pend_75 us_rci_75 numh edad hombre_casado genero instituto universidad unemp_sect d_z2 d_cc2"
global factor_op2_1 "factor_debt"  // factor_debt_2014 factor_debt  factor_egm factor_all factor_national  factor_101114
global factor_op2_11 "factor_debt_2011" 
global factor_op2_14 "factor_debt_2014" 
global factor_op2_17 "factor_debt_2017" 
global factor1 "${factor_op}"

use "$path_g\\${data_save}_dtbc2.dta", clear //use "$path_g\\${data_save}_nie.dta", clear
sum sexo zona2 sector_ind tr_edad2 educ quintile_h
replace tr_edad2=1 if edad2<=35 & tr_edad2==.
replace tr_edad2=2 if edad2>35 & edad2<=54 & tr_edad2==.
replace tr_edad2=3 if edad2>=55 & tr_edad2==.
recode sexo 2=0
joinby sexo tr_edad2 educ using "$path_g\asalariados_x2_minmax.dta", unmatched(master) update
tab _merge
recode sexo 0=2
drop _merge
g quarter=4
replace year=min(2015,year)
sum actividad sector_ind
replace sector_ind=3 if sector_ind==.  
run "$path_bs_do\layoff_jobfind0_stress.do"
replace year=year_efh
g desem_mean_y=.
sum layoffs_sect layoffs_sect_v unemployed unemployed_60 d_unemployed_60 pr_layoffs_60 d_pr_layoffs_60 lfp
sum layoffs_sect layoffs_sect_v unemployed unemployed_60 d_unemployed_60 pr_layoffs_60 d_pr_layoffs_60 lfp if lfp==1
egen layoffs_Stress=rowmax(layoffs_sect layoffs_sect_v pr_layoffs_60)
replace layoffs_Stress=unemployed if layoffs_Stress==. //replace layoffs_Stress=unemployed_60 if layoffs_Stress==. unemp_sect unemp_sect_v 
g layoffs_Stress_original=layoffs_Stress
sum year
local i0=r(min)
local i1=r(max)
g am_deuda0 = deuda_cons_banco/max(1,min(24,p_cbco)) if a1==1
replace am_deuda0 = max(0,am_deuda0) + max(0,d_dna-deuda_cons_banco)/max(1, min(12,p_ccom)) if a1==1
local Ri = 0.20
g das = max(0, min(dcbco,deuda_cons_banco) ) if a1==1
g am_deuda1 = max(0,cfdcbco)/`Ri' - ((1+`Ri')^max(1,min(36,p_cbco)))*max(0,(max(0,cfdcbco)/`Ri'-das))  if a1==1
g am_deuda1_0= max(0,cfdcbco)/`Ri' - ((1+`Ri')^max(1,min(36,p_cbco)-1))*max(0,(max(0,cfdcbco)/`Ri'-das))  if a1==1
replace am_deuda1 = max(0, max(das,am_deuda1) - am_deuda1_0) if a1==1
local Ri = 0.15
g cfas=max(0,cfdauto)+max(0,cfdsocial) if a1==1
replace das=max(0,dauto+dsocial) if a1==1
g am_deuda2 = max(0,cfas)/`Ri' - ((1+`Ri')^max(1,min(48,p_cons)))*max(0,(max(0,cfas)/`Ri'-das))  if a1==1
g am_deuda2_0= max(0,cfas)/`Ri' - ((1+`Ri')^max(1,min(48,p_cons)-1))*max(0,(max(0,cfas)/`Ri'-das))  if a1==1
replace am_deuda2 = max(0, max(das,am_deuda2) - am_deuda2_0) if a1==1
local Ri = 0.30
replace cfas = max(0,max(0,cf_dna)-max(0,cfdcbco)-max(0,cfdauto+cfdsocial))  if a1==1
replace das = max(0,max(0,d_dna)-max(0,min(dcbco,deuda_cons_banco))-max(0,dauto+dsocial))  if a1==1
g am_deuda3 = max(0,cfas)/`Ri' - ((1+`Ri')^max(1,min(24,p_ccom)))*max(0,(max(0,cfas)/`Ri'-das))  if a1==1
g am_deuda3_0= max(0,cfas)/`Ri' - ((1+`Ri')^max(1,min(24,p_ccom)-1))*max(0,(max(0,cfas)/`Ri'-das))  if a1==1
replace am_deuda3 = max(0, max(das,am_deuda3) - am_deuda3_0) if a1==1
g am_deuda=am_deuda1+am_deuda2+am_deuda3
g am_dna = min(cf_dna,am_deuda0,am_deuda)
drop am_deuda1_0 am_deuda2_0 am_deuda3_0 cfas das am_deuda1 am_deuda2 am_deuda3
pwcorr am_d*  // Also need cf_vp //cf_hip cf_dt cf_dtot  max(0,cf_dt-cf_dna)
g exp_min = min(exp_p25, exp_ndur_p25, exp_ndur2_p25) if a1==1
g expenses1 = max(0, min(simu_exp_efh, gasto_no_d, exp_ndur_p50, exp_ndur2_p50)-max(0,arriendo_impu)*vivprop) if a1==1
g expenses2 = (max(0,am_dna)+expenses1) if a1==1
g expenses3 = (max(0,cf_dna)+expenses1) if a1==1
g exp_red = max(0, expenses1-exp_min) if a1==1
qreg ing ytoth_pi i.(zona2 num_adult tr_edad2 vivprop tedu) if a1==1, q(0.50) nolog
predict ing_p50 if a1==1 
qreg ing ytoth_pi i.(zona2 num_adult tr_edad2 vivprop tedu) if a1==1, q(0.25) nolog
predict ing_p25 if a1==1 
g ln_gastos=ln(simu_exp_efh)  // ln_gastos ytoth_pi are the most important in qreg, others not so much  //  ing zona2 num_men num_adult num_sen tr_edad2 vivprop tedu
qreg ln_dna ln_gastos ytoth_pi i.(zona2 num_adult tr_edad2 vivprop tedu) i.(year) if a1==1 & d_dna>0 & d_dna<., q(${PcdebtCS}) nolog // ln_dna d_dna simu_exp_efh
predict dc_p90 if a1==1 
replace dc_p90=exp(dc_p90)
sum d_dna p_* if a1==1 & d_dna>0 & d_dna<.
g dr1 = (expenses1>exp(ing) & d_dna>dc_p90) if a1==1 & d_dna<. //& df_dna<. //debt_renewal1
g dr2 = (expenses2>exp(ing) & d_dna>dc_p90) if a1==1 & d_dna<. //& df_dna<. //debt_renewal2
g dr3 = (expenses3>exp(ing) & d_dna>dc_p90) if a1==1 & d_dna<. //& df_dna<. //debt_renewal3
g dr1_cc2 = (expenses1>exp(ing) & d_dna>${PcdebtCS}*dc_p90) if a1==1 & d_dna<. //& df_dna<. //debt_renewal1
g dr2_cc2 = (expenses2>exp(ing) & d_dna>${PcdebtCS}*dc_p90) if a1==1 & d_dna<. //& df_dna<. //debt_renewal2
g dr3_cc2 = (expenses3>exp(ing) & d_dna>${PcdebtCS}*dc_p90) if a1==1 & d_dna<. //& df_dna<. //debt_renewal3

do "$path_bs_do\Covid_Stress.do" 
do "$path_bs_do\Riot_Stress.do" 
do "$path_bs_do\Graphs_Stress.do" 
capture drop f4_*

capture g pr_jobfind_115 = (100/115)*pr_jobfind_100
capture g d_pr_jobfind_115 = (115/100)*d_pr_jobfind_100
capture g d_pr_layoffs_115 = (115/100)*d_pr_layoffs_100
forv i=`i0'/`i1' { 
quietly sum desem if year==`i' [fw=${factor_op}]
quietly replace desem_mean_y=r(mean) if year==`i'
}
forvalues i = 60(5)100 {  
quietly replace d_unemployed_`i'=d_unemployed_`i'*max(1, 1/(1-desem_mean_y) )
}
quietly g d_unemployed_115=(115/100)*d_unemployed_100*max(1, 1/(1-desem_mean_y) )
quietly g d_unemployed_115_WH=(115/100)*d_unemployed_100_WH
foreach var of varlist unemp_sect ytot_ind ing rci_pend_75 us_rci_75 debt_pi_ratio {
g `var'_original = `var' 
}
foreach i of numlist $STs { // $STs // 60(5)100 115 //  Now apply different aggregate unemployment shocks
capture drop simul_unemp ytot_ind_loss ytoth_loss dur_unem ytot_ind_loss_dur ytot_ind_loss_yr ytoth_loss_yr
global Ii=`i' //${Ii}
run "$path_bs_do\Unemp_Dur_Shock.do"  // Simulate Unemployment, then Duration, then get default probability 
predict_pr_df df_u`i' bc2_2013 "`var_list_pr0'" "if a1==1 & cf_dt>0 & cf_dt!=. & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<. & df_dna<." 
predict_pr_df df14_u`i' bc2_2014 "`var_list_pr0'" "if a1==1 & cf_dt>0 & cf_dt!=. & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<. & df_dna<."
predict_pr_df df17_u`i' bc2_2017 "`var_list_pr0'" "if a1==1 & cf_dt>0 & cf_dt!=. & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<. & df_dna<."
run "$path_bs_do\YVol_LaborQ_shocks.do"  // Simulate Other Employment shocks then get default probability 
predict_pr_df dfQ_u`i' bc2_2013 "`var_list_pr0'" "if a1==1 & cf_dt>0 & cf_dt!=. & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<. & df_dna<." 
predict_pr_df dfQ14_u`i' bc2_2014 "`var_list_pr0'" "if a1==1 & cf_dt>0 & cf_dt!=. & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<. & df_dna<."
predict_pr_df dfQ17_u`i' bc2_2017 "`var_list_pr0'" "if a1==1 & cf_dt>0 & cf_dt!=. & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<. & df_dna<."
global dfL ="dfQ"  
global dfM="bc2_2013"
global dfV="`var_list_pr0'"
run "$path_bs_do\Credit_shocks.do"  // Add Credit shocks then get default probability 
foreach var of varlist unemp_sect ytot_ind ing rci_pend_75 us_rci_75 debt_pi_ratio {
replace `var' = `var'_original
}
} //order df_u* df14_u* df17_u*, last //simu_exp_efh exp_ndur_p75 exp_p75 sd_c_sim
sum df_u* df14_u* df17_u* dfQ_u* dfQ14_u* dfQ17_u* if year==2014
char  _dta[_mi_update]
char  _dta[_mi_N]
char  _dta[_mi_style]
char  _dta[_mi_marker]
char  _dta[_mi_M]
local Xk=0
local i=50
rename df_dnam0 df_u`i'
local vlX0 = "unemp_sect_or ing_or debt_pi_ratio_or rci_pend_75_or us_rci_75_or numh edad hombre_casado instituto universidad d_z2" 
predict_pr_df df1_u`i' bc1_X`Xk' "`vlX0'" "if a1==1 & cf_dt>0 & cf_dt!=. & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<. & df1_dna<."
predict_pr_df dfK1_u`i' bc2_X`Xk' "`vlX0'" "if a1==1 & cf_dt>0 & cf_dt!=. & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<. & df_dna_k1<."
predict_pr_df df3_u`i' bc3_X`Xk' "`vlX0'" "if a1==1 & cf_dt>0 & cf_dt!=. & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<. & df3_dna<."
predict_pr_df dfK3_u`i' bc4_X`Xk' "`vlX0'" "if a1==1 & cf_dt>0 & cf_dt!=. & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<. & df_dna_k3<."
save "$path_g\\${data_save}_dtbc3.dta", replace

use "$path_g\\${data_save}_dtbc3.dta", clear //   Mortgage Default Models
sum rda if a1==1 & d_vp>0 & d_vp<., d  //bysort year: sum df*new d_dt d_vp df_dna df_vp rda  if a1==1 // use df_vp_new
replace rda=min(1,rda) if rda>0 & rda<. //sum debt_pi* rci_pen* d_vp df_vp_new if a1==1 & d_vp>0 & d_vp<. & df_vp_new<.
replace rda=min(1,rda) if rda==. & year>=2010
local vlvp = "ing debt_pi_ratio rci_pend_75 numh edad hombre_casado genero instituto universidad unemp_sect d_z2" //rda  d_cc2
probit df_vp_new `vlvp' if a1==1 & d_vp>0 & d_vp<., vce(robust) iterate(50) //cf_dt>0 & cf_dt!=. & c_vp>0 & c_vp<.
matrix bc_vp=e(b)
predict df0vp if a1==1 & d_vp>0 & d_vp<. & df_vp_new<. //predict df_vp_m if a1==1 & cf_dt>0 & cf_dt!=.
outreg2 using "$path_g\\df_VP.xls", replace
local vlV = "ing rda debt_pi_ratio rci_pend_75 numh edad hombre_casado genero instituto universidad unemp_sect d_z2" //rda  d_cc2
probit df_Vall `vlV' if a1==1 & d_vp>0 & d_vp<., vce(robust) iterate(50) //cf_dt>0 & cf_dt!=. & c_vp>0 & c_vp<.
matrix bc_V3=e(b)
predict df3V if a1==1 & d_vp>0 & d_vp<. & df_Vall<. //predict df_vp_m if a1==1 & cf_dt>0 & cf_dt!=.
outreg2 using "$path_g\\df_VP.xls", append
probit df_V1Mall `vlV' if a1==1 & d_vp>0 & d_vp<., vce(robust) iterate(50) //cf_dt>0 & cf_dt!=. & c_vp>0 & c_vp<.
matrix bc_V1=e(b)
predict df1V if a1==1 & d_vp>0 & d_vp<. & df_V1Mall<. //predict df_vp_m if a1==1 & cf_dt>0 & cf_dt!=.
outreg2 using "$path_g\\df_VP.xls", append
local vlV2 = "ing rci_pend_75 numh edad d_z2" //rda 
probit df_VSec1M `vlV2' if a1==1 & d_vp>0 & d_vp<., vce(robust) iterate(50) //cf_dt>0 & cf_dt!=. & c_vp>0 & c_vp<.
matrix bc_V1S=e(b)
predict df1VS if a1==1 & d_vp>0 & d_vp<. & df_VSec1M<.  //predict df_vp_m if a1==1 & cf_dt>0 & cf_dt!=.
outreg2 using "$path_g\\df_VP.xls", append
g df0vp_u50=df0vp
g df3V_u50=df3V
g df1V_u50=df1V
g df1VS_u50=df1VS
save "$path_g\\${data_save}_dtbc3.dta", replace  // End Mortgage Models

use "$path_g\\${data_save}_dtbc3.dta", clear //  Credit Card Default Models
// 1-Todas tarjetas al dia "Pagó monto facturado", 2-Peor estado de pago es "Pagó entre el facturado y el minimo"
// 3-Peor estado de pago es "Pagó pago minimo", 4-Peor estado de pago es "No pagó, pagó menos del minimo", 5-Todas tarjetas reportan "No sabe, no responde"
g df_TB =(tarjetas_bancaria_al_dia==4) if tarjetas_bancaria_al_dia<.
g df_TCC =(tarjetas_cc_al_dia==4) if tarjetas_cc_al_dia<.
recode tarjetas_bancaria_al_dia 5=.
recode tarjetas_cc_al_dia 5=.
log using "$path_g\default_tarjetas.log", replace 
tab tarjetas_bancaria_al_dia [fw=${factor_op}]
tab tarjetas_cc_al_dia [fw=${factor_op}]
foreach yr of numlist 10 11 14 17 { //1 11 14 17
tab tarjetas_bancaria_al_dia if a1==1 & year==20`yr' [fw=${factor`yr'}]
tab tarjetas_cc_al_dia if a1==1 & year==20`yr' [fw=${factor`yr'}]
}
local vlvp = "ing debt_pi_ratio rci_pend_75 numh edad hombre_casado genero instituto universidad unemp_sect d_z2 d_cc2" //rda
local vlX0 = "unemp_sect ing debt_pi_ratio rci_pend_75 us_rci_75 numh edad hombre_casado instituto universidad d_z2" // genero d_cc2 
oprobit tarjetas_bancaria_al_dia `vlvp' if a1==1
matrix bc_TB=e(b) //outreg2 using "$path_g\\\df_Tarjetas.xls", replace
oprobit tarjetas_cc_al_dia `vlX0' if a1==1
matrix bc_TCC=e(b)  //outreg2 using "$path_g\\\df_Tarjetas.xls", replace
probit df_TB `vlX0' if a1==1
matrix bc1_TB=e(b)
predict dfTB if a1==1 & df_TB<.
outreg2 using "$path_g\\\df_Tarjetas.xls", replace
probit df_TCC `vlX0' if a1==1
matrix bc1_TCC=e(b)
predict dfTCC if a1==1 & df_TCC<.
outreg2 using "$path_g\\\df_Tarjetas.xls", append
log close
g dfTB_u50=dfTB
g dfTCC_u50=dfTCC

g rda_original=rda
egen year_Estrato_Arriendo=group(year Estrato_Arriendo)
egen year_Estrato_2V=group(year Estrato_2V)
save "$path_g\\${data_save}_dtbc3.dta", replace   // End Credit Card Models

local rvarsC = "df_u* df14_u* df17_u* dfQ*_u*" // df_dna df_dna_m df_dna_m14
local rvars = "df_u df14_u df17_u dfQ_u dfQ14_u dfQ17_u dfQ_dr3_u dfQ_dr3_cc2_u dfQ_dr3I1_u" // dfQ_dr3I2_u //local rvars = "df_u df14_u df17_u dfQ_u dfQ14_u dfQ17_u dfQ_dr1_u dfQ_dr2_u dfQ_dr3_u dfQ_dr1_cc2_u dfQ_dr2_cc2_u dfQ_dr3_cc2_u dfQ_dr3I1_u dfQ_dr3I2_u"
local cond1 = ""
local cond11 = "keep if year==2011"
local cond14 = "keep if year==2014"
local cond17 = "keep if year==2017"
foreach yr of numlist 1 11 14 17 {  // Now calculate Debt-at-Risk (DAR) summary files and export to Excel
use "$path_g\\${data_save}_dtbc3.dta", clear // // // Households
`cond`yr''
collapse `rvarsC' if a1==1 [fw=${factor`yr'}], by(estrato_h)  //factor_debt ${factor_op} //df_dna df_dna_m14
reshape long `rvars', i(estrato_h) j(UNR)
export excel using "$path_g\\dar\\dar_dna_estrato_hh_`yr'.xls", firstrow(variables) nolabel replace
use "$path_g\\${data_save}_dtbc3.dta", clear
`cond`yr''
collapse constant `rvarsC' if a1==1 [fw=${factor`yr'}]
reshape long `rvars', i(constant) j(UNR)
export excel using "$path_g\\dar\\dar_dna_hh_`yr'.xls", firstrow(variables) nolabel replace
use "$path_g\\${data_save}_dtbc3.dta", clear  // // // % of Total Consumer Debt
`cond`yr''
collapse `rvarsC' if a1==1 [fw=${factor_op2_`yr'}], by(estrato_h)  
reshape long `rvars', i(estrato_h) j(UNR)
export excel using "$path_g\\dar\\dar_dna_estrato_`yr'.xls", firstrow(variables) nolabel replace
use "$path_g\\${data_save}_dtbc3.dta", clear
`cond`yr''
collapse constant `rvarsC' if a1==1 [fw=${factor_op2_`yr'}]
reshape long `rvars', i(constant) j(UNR)
export excel using "$path_g\\dar\\dar_dna_`yr'.xls", firstrow(variables) nolabel replace
use "$path_g\\${data_save}_dtbc3.dta", clear //   // //   Banking Consumer Debt   //
`cond`yr''
collapse `rvarsC' if a1==1 & deuda_cons_banco>0 & deuda_cons_banco<. [fw=${factor_op2_`yr'}], by(estrato_h) 
reshape long `rvars', i(estrato_h) j(UNR)
export excel using "$path_g\\dar\\dar_dna_banco_estrato_`yr'.xls", firstrow(variables) nolabel replace
use "$path_g\\${data_save}_dtbc3.dta", clear
`cond`yr''
collapse constant `rvarsC' if a1==1 & deuda_cons_banco>0 & deuda_cons_banco<. [fw=${factor_op2_`yr'}]
reshape long `rvars', i(constant) j(UNR)
export excel using "$path_g\\dar\\dar_dna_banco_`yr'.xls", firstrow(variables) nolabel replace  //    //   //      //    //   //    //  //    //
// Summarize impact of extra unemployment for debtors and non-debtors
use "$path_g\\${data_save}_dtbc3.dta", clear  // Households
g tipo_deuda=(deuda_cons_banco>0 & deuda_cons_banco<.)
`cond`yr''
collapse d_unem* if a1==1 & tipo_deuda==1 [fw=${factor`yr'}]  
export excel using "$path_g\\dar\\unemp_dna_banco_`yr'.xls", firstrow(variables) nolabel replace
use "$path_g\\${data_save}_dtbc3.dta", clear  // Households
`cond`yr''
g tipo_deuda=(d_dna>0 & d_dna<.)
collapse d_unem* if a1==1 [fw=${factor`yr'}], by(tipo_deuda)  
export excel using "$path_g\\dar\\unemp_dna_`yr'.xls", firstrow(variables) nolabel replace
}
//  //  Repeat for all waves and each EFH national wave  //	//  //	//	//		//	//	//
