local RopN = "RobMeanBeta"  
local Fac2 "factor_DT_20`yr'" 
local estrato_var "estrato_h"  
use "$path_g\\\BS_risk\Mit0\\EFH_BS${BS_nr}_2`RopN'.dta", clear  // Multiple Debt types: Social Explosion
keep *60 `estrato_var' `Fac2'
collapse dfTall_u* df3V_u* df3_u* dfK3_u* dfTB_u* dfTCC_u* [fw=`Fac2'], by(`estrato_var') 
save "$path_g\\\data_temp.dta", replace  
use "$path_g\\\BS_risk\Mit0\\EFH_BS${BS_nr}_2`RopN'.dta", clear  
keep *60 `estrato_var' `Fac2'
collapse dfTall_u* df3V_u* df3_u* dfK3_u* dfTB_u* dfTCC_u* [fw=`Fac2']
g `estrato_var'=0
joinby `estrato_var' using "$path_g\\\data_temp.dta", unmatched(both) update
drop _merge
order `estrato_var' *60, first
save "$path_g\\\data_temp.dta", replace  
export excel using "$path_gCJE\\\darDT_SE0.xls", firstrow(variables) nolabel replace  

use "$path_g\\\BS_risk\Mit0\\EFH_BS${BS_nr}_2`RopN'.dta", clear  // Multiple Debt types: Social Explosion
keep *80 `estrato_var' `Fac2'
collapse dfQTall_u* dfQ3V_u* dfQ3_u* dfQK3_u* dfQTB_u* dfQTCC_u* [fw=`Fac2'], by(`estrato_var') 
save "$path_g\\\data_temp.dta", replace  
use "$path_g\\\BS_risk\Mit0\\EFH_BS${BS_nr}_2`RopN'.dta", clear  
keep *80 `estrato_var' `Fac2'
collapse dfQTall_u* dfQ3V_u* dfQ3_u* dfQK3_u* dfQTB_u* dfQTCC_u* [fw=`Fac2']
g `estrato_var'=0
joinby `estrato_var' using "$path_g\\\data_temp.dta", unmatched(both) update
drop _merge
order `estrato_var' *80, first
save "$path_g\\\data_temp.dta", replace  
export excel using "$path_gCJE\\\darDT_SE1.xls", firstrow(variables) nolabel replace 
  
forv m=0/1 {     // Multiple Debt types: Covid (beginning), with and without policy support
global Mit = `m' 
use "$path_g\\\BS_risk\Mit${Mit}\\EFH_BS${BS_nr}_2`RopN'.dta", clear  
keep *85 `estrato_var' `Fac2'
collapse dfQTall_u* dfQ3V_u* dfQ3_u* dfQK3_u* dfQTB_u* dfQTCC_u* [fw=`Fac2'], by(`estrato_var') 
save "$path_g\\\data_temp.dta", replace  
use "$path_g\\\BS_risk\Mit${Mit}\\EFH_BS${BS_nr}_2`RopN'.dta", clear  
keep *85 `estrato_var' `Fac2'
collapse dfQTall_u* dfQ3V_u* dfQ3_u* dfQK3_u* dfQTB_u* dfQTCC_u* [fw=`Fac2']
g `estrato_var'=0
joinby `estrato_var' using "$path_g\\\data_temp.dta", unmatched(both) update
drop _merge
order `estrato_var' *85, first
save "$path_g\\\data_temp.dta", replace  
export excel using "$path_gCJE\\\darDT_CovBeg${Mit}.xls", firstrow(variables) nolabel replace  
}
//  //
