foreach Ev in estrato_h sector_h { 
local estrato_var "`Ev'"   // quintile_h estrato_h sector_h educ 
local yr=17  
local Fac1 "${factor`yr'}"  //local Fac1 "constant" //local Fac2 "factor_all"
local F=2      
global date = 100*(100*year(td(`c(current_date)'))+month(td(`c(current_date)')))+day(td(`c(current_date)'))
display("$date")

forv m=0/1 {     // 1.0 Simulation error variance
global Mit = `m'   
cap n mkdir "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDsim\\`estrato_var'\\"
forv r=2/3 {
global Rop = `r' 
local RopN = ""         //    //
if ${Rop}==1 | ${Rop}==3 {    
local RopN = "Rob"
}
if ${Rop}>=2 { 
local RopN = "`RopN'MeanBeta"  
}      //			//		//		//
local rvarsC = "dfTall_u* dfQTall*_u* dfKTall_u* dfQKTall*_u*"
local rv0 = "dfTall_u dfKTall_u dfQTall_u dfQKTall_u" 
foreach v in Tall KTall { 
local rv`v' = "dfQ`v'_dr3_u dfQ`v'_dr3I1_u" 
}
local RV = "`rv0' `rvTall' `rvKTall'"   //"`rv0'" 
local Fac2 "factor_DT_20`yr'"  // factor_debt_2014 factor_debt  factor_egm factor_all factor_national  factor_101114

local F=2     //foreach F of numlist 1 2 { // 1 2 3 //Calculate Debt-at-Risk (DAR) for each loss measure (households, debt, banking debt),
use "$path_g\\\BS_risk\Mit${Mit}\\EFH_BS${BS_nr}_2`RopN'.dta", clear  
collapse `rvarsC' if a1==1 [fw=`Fac`F''], by(`estrato_var' bs_rep) 
collapse (sd) `rvarsC', by(`estrato_var')
save "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDsim\\`estrato_var'\\SDsim_dar_Total_estrato`RopN'.dta", replace
use "$path_g\\\BS_risk\Mit${Mit}\\EFH_BS${BS_nr}_2`RopN'.dta", clear
collapse constant `rvarsC' if a1==1 [fw=`Fac`F''], by(bs_rep)
collapse (sd) constant `rvarsC'
save "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDsim\\`estrato_var'\\SDsim_dar_Total`RopN'.dta", replace     //}

local rvarsC = "dfCall_u* dfQCall*_u* dfKCall_u* dfQKCall*_u*"
local rv0 = "dfCall_u dfKCall_u dfQCall_u dfQKCall_u" 
foreach v in Call KCall { 
local rv`v' = "dfQ`v'_dr3_u dfQ`v'_dr3I1_u" 
}
local RV = "`rv0' `rvCall' `rvKCall'" //"`rv0'"  //local Fac1 "${factor`yr'}"  //local Fac1 "constant" //local Fac2 "factor_all"
local Fac2 "factor_DC_20`yr'"  // factor_debt_2014 factor_debt  factor_egm factor_all factor_national  factor_101114
local F=2  //foreach F of numlist 1 2 { // 1 2 3 //Calculate Debt-at-Risk (DAR) for each loss measure (households, debt, banking debt),
use "$path_g\\\BS_risk\Mit${Mit}\\EFH_BS${BS_nr}_2`RopN'.dta", clear  
bysort folio_efh year_efh: egen df_dna_k_folio = count(df_dna) 
keep if df_TB<. | df_TCC<. | df_dna_k_folio>0
collapse `rvarsC' if a1==1 [fw=`Fac`F''], by(`estrato_var' bs_rep) 
collapse (sd) `rvarsC', by(`estrato_var') 
save "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDsim\\`estrato_var'\\SDsim_dar_ConsTotal_estrato`RopN'.dta", replace
use "$path_g\\\BS_risk\Mit${Mit}\\EFH_BS${BS_nr}_2`RopN'.dta", clear
bysort folio_efh year_efh: egen df_dna_k_folio = count(df_dna) 
keep if df_TB<. | df_TCC<. | df_dna_k_folio>0
collapse constant `rvarsC' if a1==1 [fw=`Fac`F''], by(bs_rep)
collapse (sd) constant `rvarsC'
save "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDsim\\`estrato_var'\\SDsim_dar_ConsTotal`RopN'.dta", replace    //}  

}
}
//    //    //     //  //    //    //     //  //    //    //     //


forv m=0/1 {   // Total Variance and Variance due to the error of the coefficients
global Mit = `m'
cap n mkdir "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDstat\\`estrato_var'\\"
forv r=0/1 {
global Rop = `r' 
local RopN = ""         //    //
if ${Rop}==1 | ${Rop}==3 {    
local RopN = "Rob"
}
if ${Rop}>=2 { 
local RopN = "`RopN'MeanBeta"  
}      //			//		//		//
local rvarsC = "dfTall_u* dfQTall*_u* dfKTall_u* dfQKTall*_u*"
local rv0 = "dfTall_u dfKTall_u dfQTall_u dfQKTall_u" 
foreach v in Tall KTall { 
local rv`v' = "dfQ`v'_dr3_u dfQ`v'_dr3I1_u" 
}
local RV = "`rv0' `rvTall' `rvKTall'" // "`rv0'"   //local Fac1 "${factor`yr'}"  //local Fac1 "constant" //local Fac2 "factor_all"
local Fac2 "factor_DT_20`yr'"  // factor_debt_2014 factor_debt  factor_egm factor_all factor_national  factor_101114

local F=2     //foreach F of numlist 1 2 { // 1 2 3 //Calculate Debt-at-Risk (DAR) for each loss measure (households, debt, banking debt),
use "$path_g\\\BS_risk\Mit${Mit}\\EFH_BS${BS_nr}_2`RopN'.dta", clear  
collapse `rvarsC' if a1==1 [fw=`Fac`F''], by(`estrato_var' bs_rep) 
collapse (sd) `rvarsC', by(`estrato_var')
foreach var of varlist `rvarsC' {
rename `var' SD_`var'
}
joinby `estrato_var' using "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDsim\\`estrato_var'\\SDsim_dar_Total_estrato`RopN'MeanBeta.dta", unmatched(both) update
tab _merge
drop _merge
foreach var of varlist `rvarsC' {
replace SD_`var' = sqrt( max(0, SD_`var'^2 - `var'^2) )
drop `var'
rename SD_`var' `var' 
}
reshape long `RV', i(`estrato_var') j(UNR)
save "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDstat\\SD_dar_Total_estrato`RopN'.dta", replace
export excel using "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDstat\\`estrato_var'\\SD_dar_Total_estrato`RopN'.xls", firstrow(variables) nolabel replace 

use "$path_g\\\BS_risk\Mit${Mit}\\EFH_BS${BS_nr}_2`RopN'.dta", clear
collapse constant `rvarsC' if a1==1 [fw=`Fac`F''], by(bs_rep)
collapse (sd) constant `rvarsC'
foreach var of varlist `rvarsC' {
rename `var' SD_`var'
}
joinby constant using "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDsim\\`estrato_var'\\SDsim_dar_Total`RopN'MeanBeta.dta", unmatched(both) update
tab _merge
drop _merge
foreach var of varlist `rvarsC' {
replace SD_`var' = sqrt( max(0, SD_`var'^2 - `var'^2) )
drop `var'
rename SD_`var' `var' 
}
reshape long `RV', i(constant) j(UNR)
save "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDstat\\SD_dar_Total`RopN'.dta", replace    
export excel using "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDstat\\\`estrato_var'\\\SD_dar_Total`RopN'.xls", firstrow(variables) nolabel replace //}


local rvarsC = "dfCall_u* dfQCall*_u* dfKCall_u* dfQKCall*_u*"
local rv0 = "dfCall_u dfKCall_u dfQCall_u dfQKCall_u" 
foreach v in Call KCall { 
local rv`v' = "dfQ`v'_dr3_u dfQ`v'_dr3I1_u" 
}
local RV = "`rv0' `rvCall' `rvKCall'" // "`rv0'"   //local Fac1 "${factor`yr'}"  //local Fac1 "constant" //local Fac2 "factor_all"
local Fac2 "factor_DC_20`yr'"  // factor_debt_2014 factor_debt  factor_egm factor_all factor_national  factor_101114
local F=2  //foreach F of numlist 1 2 { // 1 2 3 //Calculate Debt-at-Risk (DAR) for each loss measure (households, debt, banking debt),

use "$path_g\\\BS_risk\Mit${Mit}\\EFH_BS${BS_nr}_2`RopN'.dta", clear  
bysort folio_efh year_efh: egen df_dna_k_folio = count(df_dna) 
keep if df_TB<. | df_TCC<. | df_dna_k_folio>0
collapse `rvarsC' if a1==1 [fw=`Fac`F''], by(`estrato_var' bs_rep) 
collapse (sd) `rvarsC', by(`estrato_var') 
foreach var of varlist `rvarsC' {
rename `var' SD_`var'
}
joinby `estrato_var' using "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDsim\\`estrato_var'\\SDsim_dar_ConsTotal_estrato`RopN'MeanBeta.dta", unmatched(both) update
tab _merge
drop _merge
foreach var of varlist `rvarsC' {
replace SD_`var' = sqrt( max(0, SD_`var'^2 - `var'^2) )
drop `var'
rename SD_`var' `var' 
}
reshape long `RV', i(`estrato_var') j(UNR)
save "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDstat\\SD_dar_ConsTotal_estrato`RopN'.dta", replace
export excel using "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDstat\\\`estrato_var'\\\SD_dar_ConsTotal_estrato`RopN'.xls", firstrow(variables) nolabel replace

use "$path_g\\\BS_risk\Mit${Mit}\\EFH_BS${BS_nr}_2`RopN'.dta", clear
bysort folio_efh year_efh: egen df_dna_k_folio = count(df_dna) 
keep if df_TB<. | df_TCC<. | df_dna_k_folio>0
collapse constant `rvarsC' if a1==1 [fw=`Fac`F''], by(bs_rep)
collapse (sd) constant `rvarsC'
foreach var of varlist `rvarsC' {
rename `var' SD_`var'
}
joinby constant using "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDsim\\`estrato_var'\\SDsim_dar_ConsTotal`RopN'MeanBeta.dta", unmatched(both) update
tab _merge
drop _merge
foreach var of varlist `rvarsC' {
replace SD_`var' = sqrt( max(0, SD_`var'^2 - `var'^2) )
drop `var'
rename SD_`var' `var' 
}
reshape long `RV', i(constant) j(UNR)
save "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDstat\\SD_dar_ConsTotal`RopN'.dta", replace  
export excel using "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDstat\\\`estrato_var'\\\SD_dar_ConsTotal`RopN'.xls", firstrow(variables) nolabel replace  //}

}
}
//    //    //     //  //    //    //     //  //    //    //     //

forv m=0/1 {     // 3.0 Total variance (simulation plus estimation variance
global Mit = `m'   
cap n mkdir "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDtotal\\`estrato_var'\\"
forv r=0/1 {
global Rop = `r' 
local RopN = ""         //    //
if ${Rop}==1 | ${Rop}==3 {    
local RopN = "Rob"
}
if ${Rop}>=2 { 
local RopN = "`RopN'MeanBeta"  
}      //			//		//		//
local rvarsC = "dfTall_u* dfQTall*_u* dfKTall_u* dfQKTall*_u*"
local rv0 = "dfTall_u dfKTall_u dfQTall_u dfQKTall_u" 
foreach v in Tall KTall { 
local rv`v' = "dfQ`v'_dr3_u dfQ`v'_dr3I1_u" 
}
local RV = "`rv0' `rvTall' `rvKTall'"   //"`rv0'" 
local Fac2 "factor_DT_20`yr'"  // factor_debt_2014 factor_debt  factor_egm factor_all factor_national  factor_101114

local F=2     //foreach F of numlist 1 2 { // 1 2 3 //Calculate Debt-at-Risk (DAR) for each loss measure (households, debt, banking debt),
use "$path_g\\\BS_risk\Mit${Mit}\\EFH_BS${BS_nr}_2`RopN'.dta", clear  
collapse `rvarsC' if a1==1 [fw=`Fac`F''], by(`estrato_var' bs_rep) 
collapse (sd) `rvarsC', by(`estrato_var')
save "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDtotal\\\\`estrato_var'\\SDtotal_dar_Total_estrato`RopN'.dta", replace
reshape long `RV', i(`estrato_var') j(UNR)
export excel using "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDtotal\\`estrato_var'\\SDtotal_dar_Total_estrato`RopN'.xls", firstrow(variables) nolabel replace 

use "$path_g\\\BS_risk\Mit${Mit}\\EFH_BS${BS_nr}_2`RopN'.dta", clear
collapse constant `rvarsC' if a1==1 [fw=`Fac`F''], by(bs_rep)
collapse (sd) constant `rvarsC'
save "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDtotal\\\`estrato_var'\\\SDtotal_dar_Total`RopN'.dta", replace     //}
reshape long `RV', i(constant) j(UNR)
export excel using "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDtotal\\\`estrato_var'\\\SDtotal_dar_Total`RopN'.xls", firstrow(variables) nolabel replace //}


local rvarsC = "dfCall_u* dfQCall*_u* dfKCall_u* dfQKCall*_u*"
local rv0 = "dfCall_u dfKCall_u dfQCall_u dfQKCall_u" 
foreach v in Call KCall { 
local rv`v' = "dfQ`v'_dr3_u dfQ`v'_dr3I1_u" 
}
local RV = "`rv0' `rvCall' `rvKCall'" //"`rv0'"  //local Fac1 "${factor`yr'}"  //local Fac1 "constant" //local Fac2 "factor_all"
local Fac2 "factor_DC_20`yr'"  // factor_debt_2014 factor_debt  factor_egm factor_all factor_national  factor_101114
local F=2  //foreach F of numlist 1 2 { // 1 2 3 //Calculate Debt-at-Risk (DAR) for each loss measure (households, debt, banking debt),
use "$path_g\\\BS_risk\Mit${Mit}\\EFH_BS${BS_nr}_2`RopN'.dta", clear  
bysort folio_efh year_efh: egen df_dna_k_folio = count(df_dna) 
keep if df_TB<. | df_TCC<. | df_dna_k_folio>0
collapse `rvarsC' if a1==1 [fw=`Fac`F''], by(`estrato_var' bs_rep) 
collapse (sd) `rvarsC', by(`estrato_var') 
save "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDtotal\\\`estrato_var'\\\SDtotal_dar_ConsTotal_estrato`RopN'.dta", replace
reshape long `RV', i(`estrato_var') j(UNR)
export excel using "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDtotal\\\`estrato_var'\\\SDtotal_dar_ConsTotal_estrato`RopN'.xls", firstrow(variables) nolabel replace

use "$path_g\\\BS_risk\Mit${Mit}\\EFH_BS${BS_nr}_2`RopN'.dta", clear
bysort folio_efh year_efh: egen df_dna_k_folio = count(df_dna) 
keep if df_TB<. | df_TCC<. | df_dna_k_folio>0
collapse constant `rvarsC' if a1==1 [fw=`Fac`F''], by(bs_rep)
collapse (sd) constant `rvarsC'
save "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDtotal\\\`estrato_var'\\\SDtotal_dar_ConsTotal`RopN'.dta", replace    //}  
reshape long `RV', i(constant) j(UNR)
export excel using "$path_g\\\BS_risk\Mit${Mit}\\F`F'\\SDtotal\\\`estrato_var'\\\SDtotal_dar_ConsTotal`RopN'.xls", firstrow(variables) nolabel replace  //}

}
}
}
//    //    //     //  //    //    //     //  //    //    //     //
